
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"


GtkWidget *spn_px, *spn_py, *spn_pz;
GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
GtkWidget *spn_graduak;
GtkWidget *ntbk_planoa;
GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
GtkWidget *spn_d,*spn_n,*spn_f;
GtkWidget *chk_paraleloa;
GtkWidget *chk_proportzioa;
GtkWidget *cmb_lista;
GtkWidget *rdb_ertz, *rdb_span, *rdb_ray;
GtkWidget *rdb_flat, *rdb_gouraud, *rdb_phong;


double bista_tam_alt = 5.0;
double bista_tam_zab = 5.0;
double bista_pos_x   = 0.0;
double bista_pos_y   = 0.0;
double bista_pos_z   = 0.0;
int    bista_prop    = 1;

int changed = 0;
int kam_zabalera = 0;
int kam_altuera = 0;
char *kam_buffer = NULL;
int bista1_zabalera = 0;
int bista1_altuera = 0;
char *bista1_buffer = NULL;
int bista2_zabalera = 0;
int bista2_altuera = 0;
char *bista2_buffer = NULL;
int bista3_zabalera = 0;
int bista3_altuera = 0;
char *bista3_buffer = NULL;

/************************************************************/
gint darea1_expose_event (GtkWidget *widget, GdkEventExpose *event)
{

    if ((widget->allocation.width != kam_zabalera || widget->allocation.height != kam_altuera) || changed) {

        kam_zabalera = widget->allocation.width;
        kam_altuera = widget->allocation.height;
        
        if (kam_buffer != NULL)
            free(kam_buffer);
        kam_buffer = (char *)malloc(kam_altuera*kam_zabalera*4);

        memset(kam_buffer,0xff,kam_zabalera*kam_altuera*4);
        
        gdk_draw_rectangle(widget->window,
                           widget->style->white_gc,
                           TRUE,
                           0, 0,
                           widget->allocation.width,
                           widget->allocation.height);

        irudia_kalkulatu(&nerekam, argiakptr, &obj, kam_buffer, kam_zabalera, kam_altuera);
    }

    gdk_draw_rgb_32_image(widget->window,
                          widget->style->white_gc,
                          0, 0,
                          kam_zabalera, kam_altuera,
                          GDK_RGB_DITHER_NONE,
                          kam_buffer,
                          kam_zabalera*4);


    return FALSE;
}

gint darea2_expose_event (GtkWidget *widget, GdkEventExpose *event)
{
    return FALSE;
}

gint darea3_expose_event (GtkWidget *widget, GdkEventExpose *event)
{
    int i,j,ind1,ind2,ertzkop;
    int x1,y1,x2,y2;
    objektua *objptr;

    objptr=&obj;
    {
        if (objptr->numcaras>0 && objptr->numvert>0 && bista_tam_alt>0 && bista_tam_zab>0) {
            for (i = 0; i < objptr->numcaras; i++)
            {
                ertzkop = objptr->tablacaras[i].numvert;
                for (j=0; j<ertzkop; j++)
                {
                    ind1=objptr->tablacaras[i].tablaindvert[j];
                    ind2=objptr->tablacaras[i].tablaindvert[(j+1)%ertzkop];

                    x1 = (objptr->tablavert[ind1].koord.x *3)+100;
                    y1 = 200-((objptr->tablavert[ind1].koord.y *3)+100);
                    x2 = (objptr->tablavert[ind2].koord.x *3)+100;
                    y2 = 200-((objptr->tablavert[ind2].koord.y *3)+100);
                    gdk_draw_line(widget->window,widget->style->black_gc,
                                  x1,y1,
                                  x2,y2);
                }
            }
        }
    }
    return FALSE;
}

gint darea4_expose_event (GtkWidget *widget, GdkEventExpose *event)
{
    return FALSE;
}

void redraw()
{
    changed = 1;
    darea1_expose_event(darea1,NULL);
    darea2_expose_event(darea2,NULL);
    darea3_expose_event(darea3,NULL);
    darea4_expose_event(darea4,NULL);
    changed = 0;
}

