
#ifndef ARGIA_H
#define ARGIA_H

#include "definiz.h"
#include "kamara_definiz.h"

#define ARGIA_EGUZKIA  1
#define ARGIA_BONBILLA 2
#define ARGIA_FOKUA    3

typedef struct {
    int mota;                     // argi mota: eguzkia, fokua, bonbilla
    puntua3 kokapena;             // argiaren zentrua
    bektorea3 norabidea;          // eguzkiaren eta fokuaren norabidea
    intentsitatea3 intentsitatea; // argiaren intentsitatea
    double angelua;               // fokuaren argiztatze angelua
} argia;

extern intentsitatea3 argia_ia;
extern double argia_kd;
extern double argia_ks;
extern long int argia_ns;

#endif // ARGIA_H
