
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "kamara.h"
#include "definiz.h"
#include "render.h"

void kamara_hasieratu(kamara *kamptr)
{
    kamptr->VRP.x=0.0;kamptr->VRP.y=0.0;kamptr->VRP.z=0.0;
    kamptr->PRP.x=0.0;kamptr->PRP.y=0.0;kamptr->PRP.z=8.0;
    kamptr->VPN.x=0.0;kamptr->VPN.y=0.0;kamptr->VPN.z=1.0;
    kamptr->VUP.x=0.0;kamptr->VUP.y=1.0;kamptr->VUP.z=0.0;
    kamptr->d=0.0;
    kamptr->n=7.5;
    kamptr->f=-15.0;
    kamptr->xmin=-8.0;
    kamptr->ymin=-8.0;
    kamptr->xmax=8.0;
    kamptr->ymax=8.0;
    kamptr->paraleloa=0;
    kamptr->kamara_mota = KAMARA_ERTZAK;
    kamptr->interpolazio_mota = KAMARA_FLAT;
}




void irudia_kalkulatu(kamara *kamptr,argilista *argiak, objektua *objptr, char *buffer,int width, int height)
{

    switch (kamptr->kamara_mota) {
    case KAMARA_ERTZAK:
        Render_Ertzak((long *)buffer,width,height,height*4,kamptr,argiak,objptr);
        break;
    case KAMARA_SPAN_SCANLINE:
        Render_SpanScanline((long *)buffer,width,height,height*4,kamptr,argiak,objptr);
        break;
    default:
        Render_Ertzak((long *)buffer,width,height,height*4,kamptr,argiak,objptr);
        break;
    }
}
