
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"
#include "menua.h"

extern GtkWidget *spn_px, *spn_py, *spn_pz;
extern GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
extern GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
extern GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
extern GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
extern GtkWidget *spn_graduak;
extern GtkWidget *ntbk_planoa;
extern GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
extern GtkWidget *spn_d,*spn_n,*spn_f;
extern GtkWidget *chk_paraleloa;
extern GtkWidget *chk_proportzioa;
GtkWidget *txt_info;
GtkWidget *rdb_eguzkia;
GtkWidget *rdb_bonbilla;
GtkWidget *rdb_fokua;
GtkWidget *lbl_angelua;
GtkWidget *frm_p1;
GtkWidget *frm_p2;
GtkWidget *spn_r;
GtkWidget *spn_g;
GtkWidget *spn_b;
GtkWidget *spn_kd;
GtkWidget *spn_ks;
GtkWidget *spn_ns;

extern double bista_tam_alt;
extern double bista_tam_zab;
extern double bista_pos_x;
extern double bista_pos_y;
extern double bista_pos_z;
extern int    bista_prop;


/************************************************************/
static void argiagehitu_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
double x,y,z,mota;

    if (gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_p2x)) == 0.0 &&
        gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_p2y)) == 0.0 &&
        gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_p2z)) == 0.0 &&
        gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_bonbilla)) != TRUE)
    {
        mezua("Errorea:","Errorea: Norabideak ezin du (0,0,0) izan.",mezuaONARTU,NULL);
    } else {

        if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_eguzkia))) {
            mota = ARGIA_EGUZKIA;
        } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_bonbilla))) {
            mota = ARGIA_BONBILLA;
        } else if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rdb_fokua))) {
            mota = ARGIA_FOKUA;
        }
        x = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_px));
        y = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_py));
        z = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_pz));
	/*  .../... */
        x = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_p2x));
        y = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_p2y));
        z = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_p2z));
	/*  .../... */
        x = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_graduak));
	/*  .../... */
        x = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_r));
        y = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_g));
        z = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_b));
	/*  .../... */
        gtk_widget_destroy(GTK_WIDGET(widget));
        redraw();
    }
}

static void argiagehitu_toggled( GtkWidget *widget, gpointer data )
{
    if (widget == rdb_eguzkia) {
        gtk_widget_set_sensitive(GTK_WIDGET(spn_graduak),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(lbl_angelua),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(frm_p1),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(frm_p2),TRUE);
    } else if (widget == rdb_bonbilla) {
        gtk_widget_set_sensitive(GTK_WIDGET(spn_graduak),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(lbl_angelua),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(frm_p2),FALSE);
        gtk_widget_set_sensitive(GTK_WIDGET(frm_p1),TRUE);
    } else if (widget == rdb_fokua) {
        gtk_widget_set_sensitive(GTK_WIDGET(spn_graduak),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(lbl_angelua),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(frm_p1),TRUE);
        gtk_widget_set_sensitive(GTK_WIDGET(frm_p2),TRUE);
    } else {
       mezua("errorea","KK: ez du balio\n",mezuaONARTU,NULL);
    }
}

void menua_argiagehitu(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox,*hbox_frame,*vbox_frm1, *vbox_p1, *vbox_p2, *vbox_rgb, *hbox_eguzkia,*hbox_bonbilla,*hbox_fokua;
    GtkWidget *p1xhbox,*p1yhbox,*p1zhbox,*p2xhbox,*p2yhbox,*p2zhbox,*action_hbox;
    GtkWidget *hbox_r, *hbox_g, *hbox_b;
    GtkWidget *hbox_angelua;
    GtkWidget *frm_mota, *frm_balioak, *frm_intents;
    GtkWidget *lbl_mezua;
    GtkWidget *tbl_frm2;
    GtkWidget *lbl_x1,*lbl_y1,*lbl_z1,*lbl_x2,*lbl_y2,*lbl_z2;
    GtkWidget *lbl_r, *lbl_g, *lbl_b;
    GtkWidget *cmd_accept,*cmd_cancel;
    GtkAdjustment *adj;
    
    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Argia gehitu");
    gtk_widget_set_usize(lei,690,305);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);

    vbox = gtk_vbox_new(FALSE,0);
    hbox_frame = gtk_hbox_new(FALSE,0);
    vbox_frm1 = gtk_vbox_new(FALSE,0);
    vbox_p1 = gtk_vbox_new(FALSE,0);
    vbox_p2 = gtk_vbox_new(FALSE,0);
    vbox_rgb = gtk_vbox_new(FALSE,0);
    hbox_eguzkia = gtk_hbox_new(FALSE,0);
    hbox_bonbilla = gtk_hbox_new(FALSE,0);
    hbox_fokua = gtk_hbox_new(FALSE,0);
    hbox_angelua = gtk_hbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    p1yhbox = gtk_hbox_new(FALSE,0);
    p1zhbox = gtk_hbox_new(FALSE,0);
    p2xhbox = gtk_hbox_new(FALSE,0);
    p2yhbox = gtk_hbox_new(FALSE,0);
    p2zhbox = gtk_hbox_new(FALSE,0);
    p1xhbox = gtk_hbox_new(FALSE,0);
    hbox_r = gtk_hbox_new(FALSE,0);
    hbox_g = gtk_hbox_new(FALSE,0);
    hbox_b = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);

    frm_mota = gtk_frame_new("Argi mota:");
    gtk_frame_set_label_align(GTK_FRAME(frm_mota),0.5,0.0);
    frm_balioak = gtk_frame_new("Argiaren balioak:");
    gtk_frame_set_label_align(GTK_FRAME(frm_balioak),0.5,0.0);
    frm_p1 = gtk_frame_new("Kokapena:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p1),0.5,0.0);
    frm_p2 = gtk_frame_new("Norabidea:");
    gtk_frame_set_label_align(GTK_FRAME(frm_p2),0.5,0.0);
    frm_intents = gtk_frame_new("Intentsitatea:");
    gtk_frame_set_label_align(GTK_FRAME(frm_intents),0.5,0.0);

    lbl_mezua = gtk_label_new("Aukeratu nolako argia:");

    rdb_eguzkia = gtk_radio_button_new_with_label(NULL,"Eguzkia");
    gtk_signal_connect_object (GTK_OBJECT (rdb_eguzkia), "toggled",
                               GTK_SIGNAL_FUNC (argiagehitu_toggled),
                               GTK_OBJECT (rdb_eguzkia));
    gtk_box_pack_start(GTK_BOX(hbox_eguzkia),rdb_eguzkia,FALSE,FALSE,10);
    rdb_bonbilla = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(rdb_eguzkia)),"Bonbilla");
    gtk_signal_connect_object (GTK_OBJECT (rdb_bonbilla), "toggled",
                               GTK_SIGNAL_FUNC (argiagehitu_toggled),
                               GTK_OBJECT (rdb_bonbilla));
    gtk_box_pack_start(GTK_BOX(hbox_bonbilla),rdb_bonbilla,FALSE,FALSE,10);
    rdb_fokua = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(rdb_eguzkia)),"Fokoa");
    gtk_signal_connect_object (GTK_OBJECT (rdb_fokua), "toggled",
                               GTK_SIGNAL_FUNC (argiagehitu_toggled),
                               GTK_OBJECT (rdb_fokua));
    gtk_box_pack_start(GTK_BOX(hbox_fokua),rdb_fokua,FALSE,FALSE,10);

    gtk_box_pack_start(GTK_BOX(vbox_frm1),hbox_eguzkia,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),hbox_bonbilla,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_frm1),hbox_fokua,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_mota), vbox_frm1);

    tbl_frm2 = gtk_table_new(3,3,FALSE);
    gtk_table_set_row_spacings(GTK_TABLE(tbl_frm2),10);

    lbl_x1 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p1xhbox), lbl_x1, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_px = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1xhbox), spn_px, TRUE, TRUE, 20);

    lbl_y1 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p1yhbox),lbl_y1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_py = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_py), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_py),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1yhbox), spn_py, TRUE, TRUE, 20);

    lbl_z1 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p1zhbox),lbl_z1,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_pz = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_pz), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_pz),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p1zhbox), spn_pz, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_p1),p1xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_p1),p1yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_p1),p1zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p1), vbox_p1);

    gtk_table_attach_defaults(GTK_TABLE(tbl_frm2),frm_p1,0,1,0,1);

    lbl_x2 = gtk_label_new("X:");
    gtk_box_pack_start (GTK_BOX(p2xhbox), lbl_x2, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2x = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2x), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2x),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2xhbox), spn_p2x, TRUE, TRUE, 20);

    lbl_y2 = gtk_label_new("Y:");
    gtk_box_pack_start(GTK_BOX(p2yhbox),lbl_y2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (-1.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2y = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2y), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2y),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2yhbox), spn_p2y, TRUE, TRUE, 20);

    lbl_z2 = gtk_label_new("Z:");
    gtk_box_pack_start(GTK_BOX(p2zhbox),lbl_z2,TRUE,TRUE,20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, -1000.0, 1000.0, 0.25, 10.0, 0.0);
    spn_p2z = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_p2z), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_p2z),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(p2zhbox), spn_p2z, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_p2),p2xhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_p2),p2yhbox,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_p2),p2zhbox,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_p2), vbox_p2);

    gtk_table_attach_defaults(GTK_TABLE(tbl_frm2),frm_p2,1,2,0,1);

    lbl_r = gtk_label_new("R:");
    gtk_box_pack_start (GTK_BOX(hbox_r), lbl_r, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.5, 0.0, 1.0, 0.1, 1.0, 0.0);
    spn_r = gtk_spin_button_new (adj, 0, 3);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_r), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_r),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_r), spn_r, TRUE, TRUE, 20);

    lbl_g = gtk_label_new("G:");
    gtk_box_pack_start (GTK_BOX(hbox_g), lbl_g, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.5, 0.0, 1.0, 0.1, 1.0, 0.0);
    spn_g = gtk_spin_button_new (adj, 0, 3);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_g), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_g),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_g), spn_g, TRUE, TRUE, 20);

    lbl_b = gtk_label_new("B:");
    gtk_box_pack_start (GTK_BOX(hbox_b), lbl_b, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.5, 0.0, 1.0, 0.1, 1.0, 0.0);
    spn_b = gtk_spin_button_new (adj, 0, 3);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_b), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_b),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_b), spn_b, TRUE, TRUE, 20);

    gtk_box_pack_start(GTK_BOX(vbox_rgb),hbox_r,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_rgb),hbox_g,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_rgb),hbox_b,FALSE,FALSE,10);

    gtk_container_add (GTK_CONTAINER(frm_intents), vbox_rgb);

    gtk_table_attach_defaults(GTK_TABLE(tbl_frm2),frm_intents,2,3,0,1);

    lbl_angelua = gtk_label_new("Angelua:");
    gtk_box_pack_start (GTK_BOX(hbox_angelua), lbl_angelua, TRUE, TRUE, 10);
    adj = (GtkAdjustment *)gtk_adjustment_new (30.0, -360.0, 360.0, 1.0, 45.0, 0.0);
    spn_graduak = gtk_spin_button_new (adj, 0, 1);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_graduak), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_graduak),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_angelua), spn_graduak, TRUE, TRUE, 10);

    gtk_table_attach_defaults(GTK_TABLE(tbl_frm2),hbox_angelua,0,1,1,2);
/*
    lbl_intentsitatea = gtk_label_new("Intents.:");
    gtk_box_pack_start (GTK_BOX(hbox_intentsitatea), lbl_intentsitatea, TRUE, TRUE, 20);
    adj = (GtkAdjustment *)gtk_adjustment_new (0.5, 0.0, 1.0, 0.1, 0.5, 0.0);
    spn_r = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_r), FALSE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_r),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_box_pack_start (GTK_BOX(hbox_intentsitatea), spn_r, TRUE, TRUE, 20);

    gtk_table_attach_defaults(GTK_TABLE(tbl_frm2),hbox_intentsitatea,1,2,1,2);
*/
    gtk_container_add (GTK_CONTAINER(frm_balioak), tbl_frm2);

    gtk_widget_set_sensitive(GTK_WIDGET(spn_graduak),FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(lbl_angelua),FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(frm_p1),FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(frm_p2),TRUE);

    cmd_accept = gtk_button_new_with_label ("Gehitu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (argiagehitu_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_mota,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_frame),frm_balioak,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);
    
    gtk_box_pack_start(GTK_BOX(vbox),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),hbox_frame,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(rdb_eguzkia);
    gtk_widget_show(rdb_bonbilla);
    gtk_widget_show(rdb_fokua);
    gtk_widget_show(hbox_eguzkia);
    gtk_widget_show(hbox_bonbilla);
    gtk_widget_show(hbox_fokua);
    gtk_widget_show(vbox_frm1);
    gtk_widget_show(frm_mota);
    gtk_widget_show(lbl_x1);
    gtk_widget_show(spn_px);
    gtk_widget_show(lbl_y1);
    gtk_widget_show(spn_py);
    gtk_widget_show(lbl_z1);
    gtk_widget_show(spn_pz);
    gtk_widget_show(p1xhbox);
    gtk_widget_show(p1yhbox);
    gtk_widget_show(p1zhbox);
    gtk_widget_show(vbox_p1);
    gtk_widget_show(frm_p1);
    gtk_widget_show(lbl_x2);
    gtk_widget_show(spn_p2x);
    gtk_widget_show(lbl_y2);
    gtk_widget_show(spn_p2y);
    gtk_widget_show(lbl_z2);
    gtk_widget_show(spn_p2z);
    gtk_widget_show(p2xhbox);
    gtk_widget_show(p2yhbox);
    gtk_widget_show(p2zhbox);
    gtk_widget_show(vbox_p2);
    gtk_widget_show(frm_p2);
    gtk_widget_show(lbl_r);
    gtk_widget_show(spn_r);
    gtk_widget_show(lbl_g);
    gtk_widget_show(spn_g);
    gtk_widget_show(lbl_b);
    gtk_widget_show(spn_b);
    gtk_widget_show(hbox_r);
    gtk_widget_show(hbox_g);
    gtk_widget_show(hbox_b);
    gtk_widget_show(vbox_rgb);
    gtk_widget_show(frm_intents);
    gtk_widget_show(spn_graduak);
    gtk_widget_show(lbl_angelua);
    gtk_widget_show(hbox_angelua);
    gtk_widget_show(tbl_frm2);
    gtk_widget_show(frm_balioak);
    gtk_widget_show(hbox_frame);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox);

    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void argiakendu_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
	int zbkia;
	char buf[100];
    zbkia=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spn_px));
    sprintf(buf,"kendu beharreko argia %d . argia da\n",zbkia);
    mezua("jakinarazpena",buf,mezuaONARTU,NULL);
    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

static void argiakendu_spn_num_changed( GtkWidget *widget, gpointer data)
{
    int argizbkia,mota;
    char str[100];

    gtk_editable_delete_text(GTK_EDITABLE(txt_info),0,-1);

    argizbkia = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spn_px));
    mota = ARGIA_EGUZKIA;
    mota = ARGIA_BONBILLA;
    mota = ARGIA_FOKUA;
        switch (mota) {
        case ARGIA_EGUZKIA:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Eguzkia\n",-1);
            sprintf(str,"Norabidea: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Intentsitatea: (r,g,b)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            break;
        case ARGIA_BONBILLA:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Bonbilla\n",-1);
            sprintf(str,"Kokapena: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Intentsitatea: (r,g,b)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            break;
        case ARGIA_FOKUA:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Fokua\n",-1);
            sprintf(str,"Kokapena: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Norabidea: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Angelua: a\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Intentsitatea: (r,g,b)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            break;
        default:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Unknown\n",-1);
            break;
        }

}

void menua_argiakendu(GtkWidget *widget, gpointer data)
{
    int mota,argikop;
    GtkWidget *lei;
    GtkWidget *vbox_main, *hbox_num, *action_hbox;
    GtkWidget *lbl_mezua, *lbl_num;
    GtkWidget *cmd_accept, *cmd_cancel;
    GtkAdjustment *adj;
    char str[100];

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Argia kendu");
    gtk_widget_set_usize(lei,270,270);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 20);

    vbox_main = gtk_vbox_new(FALSE,0);
    hbox_num = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);

    lbl_mezua = gtk_label_new("Aukeratu kendu nahi duzun argia:");
    lbl_num = gtk_label_new("Argi zenbakia:");
    gtk_box_pack_start (GTK_BOX(hbox_num), lbl_num, TRUE, TRUE, 20);
    argikop=4;
    adj = (GtkAdjustment *)gtk_adjustment_new (0.0, 0.0, argikop-1, 1.0, 1.0, 1.0);
    spn_px = gtk_spin_button_new (adj, 0, 0);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_px), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_px), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_px),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_signal_connect (GTK_OBJECT (spn_px), "changed",
                        GTK_SIGNAL_FUNC (argiakendu_spn_num_changed),
                        NULL);

    gtk_box_pack_start (GTK_BOX(hbox_num), spn_px, TRUE, TRUE, 20);
    

    txt_info = gtk_text_new(NULL,NULL);
    gtk_text_set_editable(GTK_TEXT(txt_info),FALSE);
    gtk_text_set_word_wrap(GTK_TEXT(txt_info),TRUE);

    mota = ARGIA_EGUZKIA;
    mota = ARGIA_BONBILLA;
    mota = ARGIA_FOKUA;
    switch (mota) {
        case ARGIA_EGUZKIA:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Eguzkia\n",-1);
            sprintf(str,"Norabidea: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Intentsitatea: (r,g,b)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            break;
        case ARGIA_BONBILLA:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Bonbilla\n",-1);
            sprintf(str,"Kokapena: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Intentsitatea: (r,g,b)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            break;
        case ARGIA_FOKUA:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Fokua\n",-1);
            sprintf(str,"Kokapena: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Norabidea: (x,y,z)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Angelua: a\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            sprintf(str,"Intentsitatea: (r,g,b)\n");
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,str,-1);
            break;
        default:
            gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Mota: Unknown\n",-1);
            break;
        }

    cmd_accept = gtk_button_new_with_label ("Kendu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (argiakendu_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);

    gtk_box_pack_start(GTK_BOX(vbox_main),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),hbox_num,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),txt_info,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox_main);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_num);
    gtk_widget_show(spn_px);
    gtk_widget_show(hbox_num);
    gtk_widget_show(txt_info);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox_main);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
/************************************************************/
static void argiakonfiguratu_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    double r,g,b,kd,ks,ns;

    r = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_r));
    g = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_g));
    b = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_b));
    kd = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_kd));
    ks = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_ks));
    ns = gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spn_ns));

    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menua_argiakonfiguratu(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox_main, *action_hbox, *hbox_info;
    GtkWidget *lbl_mezua, *lbl_r, *lbl_g, *lbl_b, *lbl_kd, *lbl_ks, *lbl_ns;
    GtkWidget *cmd_accept, *cmd_cancel;
    GtkWidget *frm_argia, *frm_param;
    GtkWidget *tbl_argia, *tbl_param;
    GtkAdjustment *adj;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Argia konfiguratu");
    gtk_widget_set_usize(lei,400,310);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 20);

    vbox_main = gtk_vbox_new(FALSE,0);
    hbox_info = gtk_hbox_new(FALSE,0);
    action_hbox = gtk_hbox_new(FALSE,0);

    lbl_mezua = gtk_label_new("Argiaren konfigurazioa:");

    frm_argia = gtk_frame_new("Ingurune argia:");
    gtk_frame_set_label_align(GTK_FRAME(frm_argia),0.5,0.0);

    frm_param = gtk_frame_new("Argiaren parametroak:");
    gtk_frame_set_label_align(GTK_FRAME(frm_param),0.5,0.0);

    tbl_argia = gtk_table_new(3,3,TRUE);
    gtk_table_set_row_spacings(GTK_TABLE(tbl_argia),10);

    tbl_param = gtk_table_new(3,3,TRUE);
    gtk_table_set_row_spacings(GTK_TABLE(tbl_param),10);

    lbl_r = gtk_label_new("R:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_argia),lbl_r,0,1,0,1);

    adj = (GtkAdjustment *)gtk_adjustment_new (argia_ia.r, 0.0, 1.0, 0.1, 0.25, 1.0);
    spn_r = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_r), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_r), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_r),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_table_attach_defaults(GTK_TABLE(tbl_argia),spn_r,1,2,0,1);

    lbl_g = gtk_label_new("G:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_argia),lbl_g,0,1,1,2);

    adj = (GtkAdjustment *)gtk_adjustment_new (argia_ia.g, 0.0, 1.0, 0.1, 0.25, 1.0);
    spn_g = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_g), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_g), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_g),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_table_attach_defaults(GTK_TABLE(tbl_argia),spn_g,1,2,1,2);

    lbl_b = gtk_label_new("B:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_argia),lbl_b,0,1,2,3);

    adj = (GtkAdjustment *)gtk_adjustment_new (argia_ia.b, 0.0, 1.0, 0.1, 0.25, 1.0);
    spn_b = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_b), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_b), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_b),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_table_attach_defaults(GTK_TABLE(tbl_argia),spn_b,1,2,2,3);

    gtk_container_add (GTK_CONTAINER (frm_argia),tbl_argia);

    lbl_kd = gtk_label_new("Kd:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_param),lbl_kd,0,1,0,1);

    adj = (GtkAdjustment *)gtk_adjustment_new (argia_kd, 0.0, 1.0, 0.1, 0.25, 1.0);
    spn_kd = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_kd), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_kd), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_kd),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_table_attach_defaults(GTK_TABLE(tbl_param),spn_kd,1,2,0,1);

    lbl_ks = gtk_label_new("Ks:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_param),lbl_ks,0,1,1,2);

    adj = (GtkAdjustment *)gtk_adjustment_new (argia_ks, 0.0, 1.0, 0.1, 0.25, 1.0);
    spn_ks = gtk_spin_button_new (adj, 0, 2);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_ks), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_ks), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_ks),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_table_attach_defaults(GTK_TABLE(tbl_param),spn_ks,1,2,1,2);

    lbl_ns = gtk_label_new("ns:");
    gtk_table_attach_defaults(GTK_TABLE(tbl_param),lbl_ns,0,1,2,3);

    adj = (GtkAdjustment *)gtk_adjustment_new (argia_ns, 0.0, 1000000000.0, 10, 1000, 1.0);
    spn_ns = gtk_spin_button_new (adj, 0, 0);
    gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spn_ns), FALSE);
    gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spn_ns), TRUE);
    gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spn_ns),
                                     GTK_SHADOW_ETCHED_IN);
    gtk_table_attach_defaults(GTK_TABLE(tbl_param),spn_ns,1,2,2,3);

    gtk_container_add (GTK_CONTAINER (frm_param),tbl_param);

    gtk_box_pack_start(GTK_BOX(hbox_info),frm_argia,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(hbox_info),frm_param,TRUE,TRUE,10);

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (argiakonfiguratu_cmd_accept_clicked),
                               GTK_OBJECT (lei));
    cmd_cancel = gtk_button_new_with_label ("Ezeztatu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_cancel), "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (lei));
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_accept,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(action_hbox),cmd_cancel,TRUE,TRUE,10);

    gtk_box_pack_start(GTK_BOX(vbox_main),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),hbox_info,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),action_hbox,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox_main);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(lbl_r);
    gtk_widget_show(spn_r);
    gtk_widget_show(lbl_g);
    gtk_widget_show(spn_g);
    gtk_widget_show(lbl_b);
    gtk_widget_show(spn_b);
    gtk_widget_show(tbl_argia);
    gtk_widget_show(frm_argia);
    gtk_widget_show(lbl_kd);
    gtk_widget_show(spn_kd);
    gtk_widget_show(lbl_ks);
    gtk_widget_show(spn_ks);
    gtk_widget_show(lbl_ns);
    gtk_widget_show(spn_ns);
    gtk_widget_show(tbl_param);
    gtk_widget_show(frm_param);
    gtk_widget_show(hbox_info);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(cmd_cancel);
    gtk_widget_show(action_hbox);
    gtk_widget_show(vbox_main);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}

