
#ifndef KAMARA_DEFINIZ_H
#define KAMARA_DEFINIZ_H

#include "definiz.h"

#define KAMARA_ERTZAK        1
#define KAMARA_SPAN_SCANLINE 2
#define KAMARA_RAY_TRACING   3

#define KAMARA_FLAT    1
#define KAMARA_GOURAUD 2
#define KAMARA_PHONG   3

typedef struct {
    puntua3 VRP;             // erreferentzi sistema berria
    puntua3 PRP;             // kamararen pisozioa
    bektorea3 VPN;           // begiratze norabideko bektorea
    bektorea3 VUP;           // goia adierazten duen bektorea
    puntua3 proiekzio_p;     // proiekzio puntua (PRP) koordenatu errealetan
    double f;                // hortik hurrutigo dagona ikustezian da
    double n;                // hori baino hurbilagokoa ikustezina da
    double d;                // proiekzio planora dagon distantzia
    double pplanoa;          // proiekzio planotik proiekzio punturako dis.
    double xmin;             // proiekzio lehioaren koordenatuak
    double xmax;
    double ymin;
    double ymax;
    int paraleloa;
    int aurpegiakezkutatu;
    //matrizea_t itzuli;
    int kamara_mota;
    int interpolazio_mota;
} kamara;

#endif // KAMARA_DEFINIZ_H
