
#include <stdio.h>
#include <gtk/gtk.h>
#include <math.h>
#include <malloc.h>
#include "wavefrontirakurri.h"
#include "main.h"
#include "definiz.h"
#include "kamara.h"
#include "mezua.h"
#include "menua.h"

extern GtkWidget *spn_px, *spn_py, *spn_pz;
extern GtkWidget *spn_p2x,*spn_p2y,*spn_p2z;
extern GtkWidget *spn_p3x,*spn_p3y,*spn_p3z;
extern GtkWidget *spn_p4x,*spn_p4y,*spn_p4z;
extern GtkWidget *spn_a,*spn_b,*spn_c,*spn_d;
extern GtkWidget *spn_graduak;
extern GtkWidget *ntbk_planoa;
extern GtkWidget *spn_xmin,*spn_xmax,*spn_ymin,*spn_ymax;
extern GtkWidget *spn_d,*spn_n,*spn_f;
extern GtkWidget *chk_paraleloa;
extern GtkWidget *chk_proportzioa;

extern double bista_tam_alt;
extern double bista_tam_zab;
extern double bista_pos_x;
extern double bista_pos_y;
extern double bista_pos_z;
extern int    bista_prop;


/************************************************************/
static void zerariburuz_cmd_accept_clicked( GtkWidget *widget, gpointer data )
{
    gtk_widget_destroy(GTK_WIDGET(widget));
    redraw();
}

void menua_zerariburuz(GtkWidget *widget, gpointer data)
{
    GtkWidget *lei;
    GtkWidget *vbox_main;
    GtkWidget *lbl_mezua;
    GtkWidget *txt_info;
    GtkWidget *cmd_accept;

    lei = gtk_window_new (GTK_WINDOW_DIALOG);

    gtk_window_set_title(GTK_WINDOW(lei), "KBG - Zerari buruz...");
    gtk_widget_set_usize(lei,400,310);
    gtk_window_set_position(GTK_WINDOW(lei),GTK_WIN_POS_CENTER);
    gtk_container_set_border_width (GTK_CONTAINER (lei), 20);

    vbox_main = gtk_vbox_new(FALSE,0);

    lbl_mezua = gtk_label_new("Konputagailu Bidezko Grafikoak     ver.  1.1.2");

    txt_info = gtk_text_new(NULL,NULL);
    gtk_text_set_editable(GTK_TEXT(txt_info),FALSE);
    gtk_text_set_word_wrap(GTK_TEXT(txt_info),TRUE);
    gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Copyleft 2000,2001 Ixa & Enlar.    All rights reserved\n\n",-1);
    gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"This product is distributed under GNU General Public License.\n\n",-1);
    gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Egileak:\n    Beat Iza           (benat@navegalia.com)\n    Eneko Lakunza\n\n",-1);
    gtk_text_insert(GTK_TEXT(txt_info),NULL,NULL,NULL,"Eskerrak: \n    Joseba Makazaga  (grafikotako teoria esplikatzeagatik)\n    Mayi Iza           (testeatzen laguntzeagatik)\n",-1);

    cmd_accept = gtk_button_new_with_label ("Onartu");
    gtk_signal_connect_object (GTK_OBJECT (cmd_accept), "clicked",
                               GTK_SIGNAL_FUNC (zerariburuz_cmd_accept_clicked),
                               GTK_OBJECT (lei));

    gtk_box_pack_start(GTK_BOX(vbox_main),lbl_mezua,FALSE,FALSE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),txt_info,TRUE,TRUE,10);
    gtk_box_pack_start(GTK_BOX(vbox_main),cmd_accept,FALSE,FALSE,10);
    gtk_container_add (GTK_CONTAINER (lei),vbox_main);

    gtk_widget_show(lbl_mezua);
    gtk_widget_show(txt_info);
    gtk_widget_show(cmd_accept);
    gtk_widget_show(vbox_main);
    gtk_widget_show(lei);
    gtk_window_activate_focus(GTK_WINDOW(lei));
}
